import { __awaiter, __decorate } from "tslib";
import { customElement, DOM, FASTElement } from '@microsoft/fast-element';
import { Router } from '@microsoft/fast-router';
const routerProperty = '$router';
/**
 * @beta
 * @privateRemarks
 * Created to patch an issue and act as a placeholder to improve the api ahead of upgrading to the latest. Depending on
 * how much we build on this, we may want to promote it to its own package.
 */
let AlphaRouter = class AlphaRouter extends Router.from(FASTElement) {
    connectedCallback() {
        super.connectedCallback();
        /**
         * Tactical patch for Safari 16
         * {@link https://genesisglobal.atlassian.net/browse/PA-226}
         *
         * Explicitly set the config on the $router property when we connect to the DOM.
         */
        DOM.queueUpdate(() => __awaiter(this, void 0, void 0, function* () {
            this[routerProperty].config = this.config;
        }));
    }
};
AlphaRouter = __decorate([
    customElement({
        name: 'alpha-router',
    })
], AlphaRouter);
export { AlphaRouter };
